#import "MainViewController.h"
#import "CallViewController.h"
#import "SINClientMediator.h"
#import <Sinch/Sinch.h>

@interface MainViewController () <SINCallClientDelegate>
@end

@implementation MainViewController

- (void)setClientMediator:(SINClientMediator *)clientMediator {
  _clientMediator = clientMediator;
  _clientMediator.client.callClient.delegate = self;
}

- (void)viewDidLoad {
  [super viewDidLoad];

  NSAssert(self.clientMediator != nil, @"self.clientMediator must not be nil here", @"");
  NSAssert(self.clientMediator.client != nil, @"self.clientMediator.client must not be nil here", @"");

  self.notificationLabel.numberOfLines = 10;
  self.clientMediator.client.callClient.delegate = self;
  [self.destination becomeFirstResponder];
}

- (IBAction)call:(id)sender {
  self.notificationLabel.text = @"";
  if (self.destination.text && [self.destination.text length] > 0 && [self.clientMediator.client isStarted]) {
    id<SINCall> call = [self.clientMediator.client.callClient callUserWithId:self.destination.text];
    [self performSegueWithIdentifier:@"callView" sender:call];
  }
}

- (IBAction)logout:(id)sender {
  [self.clientMediator logout:^{
    [self dismissViewControllerAnimated:YES completion:nil];
  }];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(nullable id)sender {
  if ([[segue identifier] isEqualToString:@"callView"]) {
    CallViewController *callViewController = [segue destinationViewController];
    callViewController.call = sender;
    callViewController.clientMediator = self.clientMediator;
  }
}

#pragma mark - SINCallClientDelegate

- (void)client:(id<SINCallClient>)client didReceiveIncomingCall:(id<SINCall>)call {
  [self performSegueWithIdentifier:@"callView" sender:call];
}

@end
