#import <Foundation/Foundation.h>
#import <Sinch/Sinch.h>

NS_ASSUME_NONNULL_BEGIN

typedef void (^VoidCompletion)(void);
typedef void (^ErrorCompletion)(NSError *_Nullable);

@interface SINClientMediator : NSObject

/// Logged in instance of sinch client. nil if no instance was created yet
@property (nonatomic, readonly, strong) _Nullable id<SINClient> client;

/// Call to create sinch client providing userId
/// @param userId userId with which to create sinch client
/// @param completion Blcok to be called when client was create or error happened
- (void)createClientWithUserId:(NSString *)userId completion:(ErrorCompletion)completion;

/// Call to perform client logout
/// @param completion Block to be called when logout is completed
- (void)logout:(VoidCompletion)completion;

@end

NS_ASSUME_NONNULL_END
