#import "LoginViewController.h"
#import "LoginViewController+UI.h"
#import "SINClientMediator.h"
#import "MainViewController.h"
#import "Config.h"

@implementation LoginViewController

- (void)viewDidLoad {
  [super viewDidLoad];
  self.loginButton.enabled = NO;
  self.notificationLabel.numberOfLines = 10;
  [self.nameTextField becomeFirstResponder];
  self.nameTextField.delegate = self;

  if ([APPLICATION_SECRET isEqual:@"<APPLICATION SECRET>"] || [APPLICATION_KEY isEqual:@"<APPLICATION KEY>"]) {
    self.notificationLabel.text = @"APPLICATION KEY and SECRET must be set to valid values in Config.m";
    self.nameTextField.enabled = NO;
  }
}

- (IBAction)login:(UIButton *)sender {
  self.notificationLabel.text = @"";
  self.loginButton.enabled = NO;

  NSAssert(self.clientMediator != nil, @"self.clientMediator must not be nil here", @"");

  NSString *userId = self.nameTextField.text;
  [self.clientMediator createClientWithUserId:userId
                                   completion:^(NSError *_Nullable error) {
                                     if (error == nil) {
                                       [self performSegueWithIdentifier:@"mainView" sender:self];
                                     } else {
                                       self.notificationLabel.text = error.localizedDescription;
                                     }
                                     dispatch_async(dispatch_get_main_queue(), ^{
                                       self.loginButton.enabled = YES;
                                     });
                                   }];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(nullable id)sender {
  if ([[segue identifier] isEqualToString:@"mainView"]) {
    MainViewController *mainViewController = [segue destinationViewController];
    mainViewController.clientMediator = self.clientMediator;
  }
}

@end
